<template>
  <div >
    <LeaveForm
      v-bind.sync="note"
      v-on:submit="submit"
      v-on:cancel="cancel"
      v-bind:loading="loading"
    >
    </LeaveForm>
  </div>
</template>

<script>

import LeaveForm from '@/components/leave/LeaveForm.vue';
import { getAuthenticatedUser } from '@/fb';
// import Logger from '@/logger/index';
import { mapGetters } from 'vuex';
import Note from '@/models/Note';

export default {
  components: {
    LeaveForm,
  },
  data() {
    return {
      note: new Note(),
      loading: false,
    };
  },
  props: {
    id: {
      type: String,
      required: true,
    },
  },
  computed: {
    ...mapGetters({
      snackbarText: 'getSnackbarText',
      showSnackbar: 'getShowSnackbar',
      user: 'getUser',
    }),
  },
  mounted() {
    getAuthenticatedUser().then((user) => {
      this.note.uid = user.uid;
      this.note.id = this.id;
      console.log('this is note ID', this.note.id);
      this.note.fetch();
    });
  },
  methods: {
    submit() {
      this.loading = true;
      this.note.update().then(() => {
        console.log('Done creating note', this.note.id);
        this.$store.dispatch('setSnackbarText', 'Updating leave list');
        this.$store.dispatch('setShowSnackbar', true);
        this.$router.replace({ name: 'LeaveList' });
      });
    },
    cancel() {
      this.$router.replace({ name: 'LeaveList' });
    },
  },
};
</script>
